package ${entityPackageName};

<#list importPacks as pack>
<#if pack == "BigDecimal">
import java.math.${pack};
</#if>
<#if pack == "java.util.Date">
import ${pack};
</#if>
</#list>
import com.mortals.framework.model.BaseEntityLong;
/**
*
* Description:${entityClassName}
* date: ${date?datetime}
*/
public class ${entityClassName}Entity extends BaseEntityLong{
    private static final long serialVersionUID = ${serialVersionUID?c}L;
<#list fields as field>

    <#if (field.pk)??>
    <#else>
    <#if field.columnName!='id'>
    /**
    * ${field.remarks}
    */
    private ${(field.typeName?split("."))?last} ${field.attName};
    </#if>
    </#if>
</#list>

    public ${entityClassName}Entity(){

    }
<#list fields as field>
    <#if (field.pk)?? && field.columnName!='id'>
    /**
    * 获取 ${field.remarks}
    * @return ${field.attName}
    */
    public ${(field.typeName?split("."))?last} get${field.attName?cap_first}() {
        return getId();
    }
    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}
    */
    public void set${field.attName?cap_first}(${(field.typeName?split("."))?last} ${field.attName}) {
        setId(${field.attName});
    }
    <#else>
    <#if field.columnName!='id'>
    /**
    * 获取 ${field.remarks}
    * @return ${field.attName}
    */
    public ${(field.typeName?split("."))?last} get${field.attName?cap_first}() {
        return this.${field.attName};
    }
    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}
    */
    public void set${field.attName?cap_first}(${(field.typeName?split("."))?last} ${field.attName}) {
        this.${field.attName} = ${field.attName};
    }
    </#if>
    </#if>
<#--    <#if field.columnName != "id">
    /**
    * 获取 ${field.remarks}
    * @return ${field.columnName}
    */
    public ${(field.typeName?split("."))?last} get${field.columnName?cap_first}() {
        return this.${field.columnName};
    }
    /**
    * 设置 ${field.remarks}
    * @param ${field.columnName}
    */
    public void set${field.columnName?cap_first}(${(field.typeName?split("."))?last} ${field.columnName}) {
        this.${field.columnName} = ${field.columnName};
    }
    </#if>-->
</#list>

    @Override
    public int hashCode() {
        return this.getId().hashCode();
    }
    @Override
    public boolean equals(Object obj) {
        if (obj == null)
            return false;
        if (obj instanceof ${entityClassName}Entity) {
            ${entityClassName}Entity tmp = (${entityClassName}Entity) obj;
            if (this.getId().longValue() == tmp.getId().longValue()) {
                return true;
            }
        }
        return false;
    }

    public String toString(){
        StringBuilder sb = new StringBuilder("");
        sb
        <#list fields as field>
        .append(",${field.attName}:").append(get${field.attName?cap_first}())
        </#list>;
        return sb.toString();
    }

    public void initAttrValue(){
    <#list fields as field>
     <#if field.columnName != "id">
         this.${field.attName} = null;
     </#if>
    </#list>
    }
}