package ${entityPackageName};

import java.util.List;
<#list importPacks as pack>
<#if pack == "BigDecimal">
import java.math.${pack};
</#if>
<#if pack == "java.util.Date">
import ${pack};
</#if>
</#list>

/**
*
* Description:${entityClassName}
* date: ${date?datetime}
*/
public class ${entityClassName}Query extends ${entityClassName}Entity{
    private static final long serialVersionUID = ${serialVersionUID?c}L;
<#list fields as field>
<#if field.typeName == "java.lang.Long">
    /** 开始 ${field.remarks} */
    private Long ${field.attName}Start;

    /** 结束 ${field.remarks} */
    private Long ${field.attName}End;

    /** 增加 ${field.remarks} */
    private Long ${field.attName}Increment;

    /** ${field.remarks} */
    private List <Long> ${field.attName}List;

    <#elseif field.typeName == "String">

    /** ${field.remarks} */
    private List<String> ${field.attName}List;
    <#elseif field.typeName == "java.lang.Integer">

    /** 开始 ${field.remarks} */
    private Integer ${field.attName}Start;

    /** 结束 ${field.remarks} */
    private Integer ${field.attName}End;

    /** 增加 ${field.remarks} */
    private Integer ${field.attName}Increment;

    /** ${field.remarks} */
    private List <Integer> ${field.attName}List;
    <#elseif field.typeName == "java.util.Date">
    /** 开始 ${field.remarks} */
    private String ${field.attName}Start;

    /** 结束 ${field.remarks} */
    private String ${field.attName}End;
    <#elseif field.typeName == "BigDecimal">

    /** 开始 ${field.remarks} */
    private BigDecimal ${field.attName}Start;

    /** 结束 ${field.remarks} */
    private BigDecimal ${field.attName}End;

    /** 增加 ${field.remarks} */
    private BigDecimal ${field.attName}Increment;

    /** ${field.remarks} */
    private List <BigDecimal> ${field.attName}List;
</#if>
</#list>

    /** OR条件集合，列表项之间是OR，项内容之间是AND，如：(list[0].1 and list[0].2) or (list[1].3 and list[1].4) */
    private List<${entityClassName}Query> orConditionList;

    /** AND条件集合，列表项之间是AND，项内容之间是OR，如：(list[0].1 or list[0].2) and (list[1].3 or list[1].4) */
    private List<${entityClassName}Query> andConditionList;


    public ${entityClassName}Query(){
    }

    <#list fields as field>
    <#if field.typeName == "java.lang.Long">
    /**
    * 获取 开始 ${field.remarks}
    * @return ${field.attName}Start
    */
    public Long get${field.attName?cap_first}Start(){
    return this.${field.attName}Start;
    }

    /**
    * 设置 开始 ${field.remarks}
    * @param ${field.attName}Start
    */
    public void set${field.attName?cap_first}Start(Long ${field.attName}Start){
    this.${field.attName}Start = ${field.attName}Start;
    }

    /**
    * 获取 结束 ${field.remarks}
    * @return ${field.attName}End
    */
    public Long get${field.attName?cap_first}End(){
    return this.${field.attName}End;
    }

    /**
    * 设置 结束 ${field.remarks}
    * @param ${field.attName}End
    */
    public void set${field.attName?cap_first}End(Long ${field.attName}End){
    this.${field.attName}End = ${field.attName}End;
    }

    /**
    * 获取 增加 ${field.remarks}
    * @return ${field.attName}Increment
    */
    public Long get${field.attName?cap_first}Increment(){
    return this.${field.attName}Increment;
    }

    /**
    * 设置 增加 ${field.remarks}
    * @param ${field.attName}Increment
    */
    public void set${field.attName?cap_first}Increment(Long ${field.attName}Increment){
    this.${field.attName}Increment = ${field.attName}Increment;
    }

    /**
    * 获取 ${field.remarks}
    * @return ${field.attName}List
    */
    public List<Long> get${field.attName?cap_first}List(){
    return this.${field.attName}List;
    }

    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}List
    */
    public void set${field.attName?cap_first}List(List<Long> ${field.attName}List){
        this.${field.attName}List = ${field.attName}List;
        }
    </#if>
    <#if field.typeName == "String">
    /**
    * 获取 ${field.remarks}
    * @return ${field.attName}List
    */
    public List<String> get${field.attName?cap_first}List(){
        return this.${field.attName}List;
    }

    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}List
    */
    public void set${field.attName?cap_first}List(List<String> ${field.attName}List){
        this.${field.attName}List = ${field.attName}List;
    }
    </#if>
    <#if field.typeName == "java.lang.Integer">
    /**
    * 获取 开始 ${field.remarks}
    * @return ${field.attName}Start
    */
    public Integer get${field.attName?cap_first}Start(){
        return this.${field.attName}Start;
    }

    /**
    * 设置 开始 ${field.remarks}
    * @param ${field.attName}Start
    */
    public void set${field.attName?cap_first}Start(Integer ${field.attName}Start){
        this.${field.attName}Start = ${field.attName}Start;
    }

    /**
    * 获取 结束 ${field.remarks}
    * @return ${field.attName}End
    */
    public Integer get${field.attName?cap_first}End(){
        return this.${field.attName}End;
    }

    /**
    * 设置 结束 ${field.remarks}
    * @param ${field.attName}End
    */
    public void set${field.attName?cap_first}End(Integer ${field.attName}End){
        this.${field.attName}End = ${field.attName}End;
    }

    /**
    * 获取 增加 ${field.remarks}
    * @return ${field.attName}Increment
    */
    public Integer get${field.attName?cap_first}Increment(){
        return this.${field.attName}Increment;
    }

    /**
    * 设置 增加 ${field.remarks}
    * @param ${field.attName}Increment
    */
    public void set${field.attName?cap_first}Increment(Integer ${field.attName}Increment){
        this.${field.attName}Increment = ${field.attName}Increment;
    }

    /**
    * 获取 ${field.remarks}
    * @return ${field.attName}List
    */
    public List<Integer> get${field.attName?cap_first}List(){
        return this.${field.attName}List;
    }

    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}List
    */
    public void set${field.attName?cap_first}List(List<Integer> ${field.attName}List){
        this.${field.attName}List = ${field.attName}List;
    }
    </#if>
    <#if field.typeName == "BigDecimal">
    /**
    * 获取 开始 ${field.remarks}
    * @return ${field.attName}Start
    */
    public BigDecimal get${field.attName?cap_first}Start(){
        return this.${field.attName}Start;
    }

    /**
    * 设置 开始 ${field.remarks}
    * @param ${field.attName}Start
    */
    public void set${field.attName?cap_first}Start(BigDecimal ${field.attName}Start){
        this.${field.attName}Start = ${field.attName}Start;
    }

    /**
    * 获取 结束 ${field.remarks}
    * @return ${field.attName}End
    */
    public BigDecimal get${field.attName?cap_first}End(){
        return this.${field.attName}End;
    }

    /**
    * 设置 结束 ${field.remarks}
    * @param ${field.attName}End
    */
    public void set${field.attName?cap_first}End(BigDecimal ${field.attName}End){
        this.${field.attName}End = ${field.attName}End;
    }

    /**
    * 获取 增加 ${field.remarks}
    * @return ${field.attName}Increment
    */
    public BigDecimal get${field.attName?cap_first}Increment(){
        return this.${field.attName}Increment;
    }

    /**
    * 设置 增加 ${field.remarks}
    * @param ${field.attName}Increment
    */
    public void set${field.attName?cap_first}Increment(BigDecimal ${field.attName}Increment){
        this.${field.attName}Increment = ${field.attName}Increment;
    }

    /**
    * 获取 ${field.remarks}
    * @return ${field.attName}List
    */
    public List<BigDecimal> get${field.attName?cap_first}List(){
        return this.${field.attName}List;
    }

    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}List
    */
    public void set${field.attName?cap_first}List(List<BigDecimal> ${field.attName}List){
        this.${field.attName}List = ${field.attName}List;
    }
    </#if>
    <#if field.typeName == "java.util.Date">
    /**
    * 获取 开始 ${field.remarks}
    * @return ${field.attName}Start
    */
    public String get${field.attName?cap_first}Start(){
    return this.${field.attName}Start;
    }

    /**
    * 设置 开始 ${field.remarks}
    * @param ${field.attName}Start
    */
    public void set${field.attName?cap_first}Start(String ${field.attName}Start){
    this.${field.attName}Start = ${field.attName}Start;
    }

    /**
    * 获取 结束 ${field.remarks}
    * @return ${field.attName}End
    */
    public String get${field.attName?cap_first}End(){
    return this.${field.attName}End;
    }

    /**
    * 设置 结束 ${field.remarks}
    * @param ${field.attName}End
    */
    public void set${field.attName?cap_first}End(String ${field.attName}End){
    this.${field.attName}End = ${field.attName}End;
    }
    </#if>
    </#list>

    <#list fields as field>
	<#if field.typeName == "java.lang.Long">

	/**
    * 设置  ${field.remarks}
    * @param ${field.attName}
    */
    public ${entityClassName}Query ${field.attName}(Long ${field.attName}){
	    set${field.attName?cap_first}(${field.attName});
		return this;
    }
	
	 /**
    * 设置 开始 ${field.remarks}
    * @param ${field.attName}Start
    */
    public ${entityClassName}Query ${field.attName}Start(Long ${field.attName}Start){
		this.${field.attName}Start = ${field.attName}Start;
		return this;
    }

    /**
    * 设置 结束 ${field.remarks}
    * @param ${field.attName}End
    */
    public ${entityClassName}Query ${field.attName}End(Long ${field.attName}End){
		this.${field.attName}End = ${field.attName}End;
		return this;
    }

    /**
    * 设置 增加 ${field.remarks}
    * @param ${field.attName}Increment
    */
    public ${entityClassName}Query ${field.attName}Increment(Long ${field.attName}Increment){
		this.${field.attName}Increment = ${field.attName}Increment;
		return this;
    }

    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}List
    */
    public ${entityClassName}Query ${field.attName}List(List<Long> ${field.attName}List){
        this.${field.attName}List = ${field.attName}List;
		return this;
        }
    </#if>
    <#if field.typeName == "String">
	/**
    * 设置 ${field.remarks}
    * @param ${field.attName}
    */
    public ${entityClassName}Query ${field.attName}(String ${field.attName}){
        set${field.attName?cap_first}(${field.attName});
		return this;
    }


    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}List
    */
    public ${entityClassName}Query ${field.attName}List(List<String> ${field.attName}List){
        this.${field.attName}List = ${field.attName}List;
		return this;
    }
    </#if>
    <#if field.typeName == "java.lang.Integer">
	
	/**
    * 设置  ${field.remarks}
    * @param ${field.attName}
    */
    public ${entityClassName}Query ${field.attName}(Integer ${field.attName}){
        set${field.attName?cap_first}(${field.attName});
		return this;
    }

    /**
    * 设置 开始 ${field.remarks}
    * @param ${field.attName}Start
    */
    public ${entityClassName}Query ${field.attName}Start(Integer ${field.attName}Start){
        this.${field.attName}Start = ${field.attName}Start;
		return this;
    }


    /**
    * 设置 结束 ${field.remarks}
    * @param ${field.attName}End
    */
    public ${entityClassName}Query ${field.attName}End(Integer ${field.attName}End){
        this.${field.attName}End = ${field.attName}End;
		return this;
    }


    /**
    * 设置 增加 ${field.remarks}
    * @param ${field.attName}Increment
    */
    public ${entityClassName}Query ${field.attName}Increment(Integer ${field.attName}Increment){
        this.${field.attName}Increment = ${field.attName}Increment;
		return this;
    }


    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}List
    */
    public ${entityClassName}Query ${field.attName}List(List<Integer> ${field.attName}List){
        this.${field.attName}List = ${field.attName}List;
		return this;
    }
    </#if>
    <#if field.typeName == "BigDecimal">

	/**
    * 设置  ${field.remarks}
    * @param ${field.attName}
    */
    public ${entityClassName}Query ${field.attName}(BigDecimal ${field.attName}){
        set${field.attName?cap_first}(${field.attName});
		return this;
    }

    /**
    * 设置 开始 ${field.remarks}
    * @param ${field.attName}Start
    */
    public ${entityClassName}Query ${field.attName}Start(BigDecimal ${field.attName}Start){
        this.${field.attName}Start = ${field.attName}Start;
		return this;
    }


    /**
    * 设置 结束 ${field.remarks}
    * @param ${field.attName}End
    */
    public ${entityClassName}Query ${field.attName}End(BigDecimal ${field.attName}End){
        this.${field.attName}End = ${field.attName}End;
		return this;
    }


    /**
    * 设置 增加 ${field.remarks}
    * @param ${field.attName}Increment
    */
    public ${entityClassName}Query ${field.attName}Increment(BigDecimal ${field.attName}Increment){
        this.${field.attName}Increment = ${field.attName}Increment;
		return this;
    }


    /**
    * 设置 ${field.remarks}
    * @param ${field.attName}List
    */
    public ${entityClassName}Query ${field.attName}List(List<BigDecimal> ${field.attName}List){
        this.${field.attName}List = ${field.attName}List;
		return this;
    }
    </#if>
    <#if field.typeName == "java.util.Date">

    /**
    * 设置 开始 ${field.remarks}
    * @param ${field.attName}Start
    */
    public ${entityClassName}Query ${field.attName}Start(String ${field.attName}Start){
		this.${field.attName}Start = ${field.attName}Start;
		return this;
    }


    /**
    * 设置 结束 ${field.remarks}
    * @param ${field.attName}End
    */
    public ${entityClassName}Query ${field.attName}End(String ${field.attName}End){
		this.${field.attName}End = ${field.attName}End;
		return this;
    }
    </#if>
    </#list>


    /**
    * 获取 OR条件集合，列表项之间是OR，项内容之间是AND，如：(list[0].1 and list[0].2) or (list[1].3 and list[1].4)
    * @return orConditionList
    */
    public List<${entityClassName}Query> getOrConditionList(){
    return this.orConditionList;
    }

    /**
    * 设置 OR条件集合，列表项之间是OR，项内容之间是AND，如：(list[0].1 and list[0].2) or (list[1].3 and list[1].4)
    * @param orConditionList
    */
    public void setOrConditionList(List<${entityClassName}Query> orConditionList){
        this.orConditionList = orConditionList;
    }

    /**
    * 获取 AND条件集合，列表项之间是AND，项内容之间是OR，如：(list[0].1 or list[0].2) and (list[1].3 or list[1].4)
    * @return andConditionList
    */
    public List<${entityClassName}Query> getAndConditionList(){
        return this.andConditionList;
    }

    /**
    * 设置 AND条件集合，列表项之间是AND，项内容之间是OR，如：(list[0].1 or list[0].2) and (list[1].3 or list[1].4)
    * @param andConditionList
    */
    public void setAndConditionList(List<${entityClassName}Query> andConditionList){
        this.andConditionList = andConditionList;
    }

}