package ${entityPackageName};

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.mortals.framework.web.BaseCRUDJsonController;
import org.springframework.web.bind.annotation.PostMapping;
import com.alibaba.fastjson.JSONObject;
import ${pack}.model.${entityClassName}Entity;
import ${pack}.service.${entityClassName}Service;


/**
* <p>Title: ${entityDesc}</p>
* <p>Description: ${entityClassName}Controller  </p>
* <p>Copyright: Copyright &reg;  </p>
* <p>Company: </p>
* @author
* @version 1.0.0
*/
@RestController
@RequestMapping("${RequestMapping}")
public class ${entityClassName}Controller extends BaseCRUDJsonController<${entityClassName}Service,${entityClassName}Form,${entityClassName}Entity,Long> {

    public ${entityClassName}Controller(){
        super.setFormClass(${entityClassName}Form.class);
        super.setModuleDesc( "${entityDesc}");
    }

    /**
    * 查询${entityDesc}
    */
    @PostMapping(value="list")
    public String list(${entityClassName}Form form) {
    try{
        return super.list(form);
    }catch(Exception e){
        log.error("查询${entityDesc}列表错误",e);
        JSONObject ret = new JSONObject();
        ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
        ret.put(KEY_RESULT_MSG, super.convertException(e));
        return ret.toJSONString();
        }
    }
    /**
    * 添加${entityDesc}
    */
    @PostMapping(value="add")
    public String add(${entityClassName}Form form) {
        try{
            return super.add(form);
        }catch(Exception e){
            log.error("添加${entityDesc}错误",e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }
    /**
    * 编辑${entityDesc}
    */
    @PostMapping(value="edit")
    public String edit(${entityClassName}Form form) {
        try{
            return super.edit(form);
        }catch(Exception e){
            log.error("编辑${entityDesc}错误",e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }
    /**
    * 保存${entityDesc}
    */
    @PostMapping(value="save")
    public String save(${entityClassName}Form form) {
        try{
            return super.save(request, response, form);
        }catch(Exception e){
            log.error("保存${entityDesc}错误",e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }
    /**
    * 删除${entityDesc}
    */
    @PostMapping(value="delete")
    public String delete(${entityClassName}Form form) {
        try{
            return super.delete(request, response, form);
        }catch(Exception e){
            log.error("删除${entityDesc}错误",e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }
    /**
    * 查看${entityDesc}
    */
    @PostMapping(value="view")
    public String view(${entityClassName}Form form) {
        try{
            return super.view(request, response, form);
        }catch(Exception e){
            log.error("查看${entityDesc}错误",e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }


}