<#macro compress_single_line>
    <#local captured><#nested></#local>
    ${ captured?replace("\\n\\r", "", "rm") }
</#macro>
<#list tables as table>
DROP TABLE IF EXISTS `${table.tableName}`;
<@compress_single_line>
CREATE TABLE `${table.tableName}`(
<#list table.fields as field>
    <#if (field.pk)??>
    <#if field.autoInc=='true'>
        `${field.columnName}` ${field.sourceColumnType} NOT NULL  auto_increment  COMMENT '${field.remarks}',
    <#else >
        `${field.columnName}` ${field.sourceColumnType} NOT NULL   COMMENT '${field.remarks}',
    </#if>
    <#else>
        `${field.columnName}` ${field.sourceColumnType} ${ (field.isNotNull == '是') ?string('NOT NULL','DEFAULT NULL')}<#if (field.defaultValue)??> default '${field.defaultValue}'</#if> COMMENT '${field.remarks}',
</#if>
</#list>
PRIMARY KEY  (`${table.pk}`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='${table.tableDesc}';
</@compress_single_line>

</#list>


<#list menus as menu>
<#--INSERT INTO `mortals_iot_menu` VALUES ('${menu.id}', '${menu.name}', '${menu.path}', '${menu.parentId}', '${menu.orderId}', '1', '0', '0','', '${menu.imgPath}', '', '', '0', '0', '3', null, null, null);-->
INSERT INTO `mortals_xhx_menu` VALUES ('${menu.id}', '${menu.name}', '${menu.path}', '${menu.parentId}', '${menu.orderId}','1','0','0','', null, '', '', '0', '0', '3',null, null, null);
</#list>